<?php
/************************************************************************
 * MXChange v0.2.1                                    Start: 01/28/2004 *
 * ================                             Last change: 12/13/2004 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : what-list_links.php                              *
 * -------------------------------------------------------------------- *
 * Short description : List unconfirmed mails of a member               *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Unbest&auml;tigte Mails eines Mitgliedes auflisten   *
 * -------------------------------------------------------------------- *
 * $Revision::                                                        $ *
 * $Date::                                                            $ *
 * $Tag:: 0.2.1-FINAL                                                 $ *
 * $Author::                                                          $ *
 * Needs to be in all Files and every File needs "svn propset           *
 * svn:keywords Date Revision" (autoprobset!) at least!!!!!!            *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2009 by Roland Haeder                           *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if ((!defined('__SECURITY')) || (!isAdmin())) {
	die();
} // END - if

// Add description as navigation point
addMenuDescription('admin', __FILE__);

if (!isExtensionActive('mailid')) {
	loadTemplate('admin_settings_saved', false, generateExtensionInactiveNotInstalledMessage('mailid'));
	return;
} // END - if

if (isGetRequestElementSet('userid')) {
	// Check if the user already exists
	$result = SQL_QUERY_ESC("SELECT surname, family, email FROM `{?_MYSQL_PREFIX?}_user_data` WHERE `userid`=%s LIMIT 1",
	array(bigintval(getRequestElement('userid'))), __FILE__, __LINE__);

	// Is there an entry?
	if (SQL_NUMROWS($result) == 1) {
		// Loads surname, family's name and the email address
		list($surname, $family, $email) = SQL_FETCHROW($result);
		SQL_FREERESULT($result);

		// Grab user's all unconfirmed mails
		if (isExtensionActive('bonus')) {
			// Load bonus ID
			$result = SQL_QUERY_ESC("SELECT stats_id, bonus_id, link_type FROM `{?_MYSQL_PREFIX?}_user_links` WHERE `userid`=%s ORDER BY `id`",
			array(bigintval(getRequestElement('userid'))), __FILE__, __LINE__);
		} else {
			// Load stats ID (2nd will be ignored later! But it is needed for the same fetchrow command)
			$result = SQL_QUERY_ESC("SELECT stats_id, stats_id, link_type FROM `{?_MYSQL_PREFIX?}_user_links` WHERE `userid`=%s ORDER BY `id` ASC",
				array(bigintval(getRequestElement('userid'))), __FILE__, __LINE__);
		}

		// Get number of rows from the query
		$nums = SQL_NUMROWS($result);

		if ($nums > 0) {
			// Some unconfirmed mails left
			if (getRequestElement('del') == "all") {
				// Delete all unconfirmed mails by this user
				SQL_QUERY_ESC("DELETE LOW_PRIORITY FROM `{?_MYSQL_PREFIX?}_user_links` WHERE `userid`=%s LIMIT %s",
					array(bigintval(getRequestElement('userid')), $nums), __FILE__, __LINE__);

				// Prepare mail and send it away
				$message = loadEmailTemplate('admin-del_links', $nums, bigintval(getRequestElement('userid')));
				sendEmail($email, getMessage('ADMIN_DEL_LINK_SUBJ'), $message);

				// Display message
				loadTemplate('admin_settings_saved', false, getMessage('ADMIN_LINKS_DELETED'));
			} else {
				// Init variables
				$OUT = ''; $SW = 2;

				// List all unconfirmed mails
				// @TODO Find a way to rewrite this. See some lines above for different queries
				while (list($id, $id2, $type) = SQL_FETCHROW($result)) {
					// Initializes some variables
					$cat = '';
					$DATA = '';
					$PROBLEM = getMessage('GENERAL_MAIL_PROBLEM');
					$result_data = false; // Closes Bug #58

					// Load data from stats table...
					// @TODO Rewrite this to includes/filter
					switch ($type) {
						case 'NORMAL':
							$result_data = SQL_QUERY_ESC("SELECT `subject`, `timestamp_ordered`, `cat_id` FROM `{?_MYSQL_PREFIX?}_user_stats` WHERE `id`=%s LIMIT 1",
								array(bigintval($id)), __FILE__, __LINE__);
							$type = 'mailid'; $DATA = $id; $PROBLEM = getMessage('NORMAL_MAIL_PROBLEM');
							$LINK = "<a href=\"{?URL?}/mailid.php?userid=".getRequestElement('userid')."&amp;mailid=".$id."\" target=\"_blank\">".$id."</a>";
							break;

						case 'BONUS':
							$result_data = SQL_QUERY_ESC("SELECT `subject`, `timestamp`, `cat_id` FROM `{?_MYSQL_PREFIX?}_bonus` WHERE `id`=%s LIMIT 1",
								array(bigintval($id2)), __FILE__, __LINE__);
							$type = 'bonusid'; $DATA = $id2; $PROBLEM = getMessage('BONUS_MAIL_PROBLEM');
							$LINK = "<a href=\"{?URL?}/mailid.php?userid=".getRequestElement('userid')."&amp;bonusid=".$id2."\" target=\"_blank\">".$id2."</a>";
							break;

						default: // Problem in application detected!
							// Log the error
							logDebugMessage(__FILE__, __LINE__, sprintf("Invalid email type %s detected.", $type));
							break;
					}

					if (SQL_NUMROWS($result_data) == 1) {
						// Mail was found!
						list($subject, $timestamp, $cat) = SQL_FETCHROW($result_data);
						SQL_FREERESULT($result_data);
						if (empty($subject)) $subject = getMessage('DEFAULT_SUBJECT_LINE');

						// Prepare data for the row template
						$content = array(
							'sw'      => $SW,
							'link'    => $LINK,
							'subject' => $subject,
							'stamp'   => generateDateTime($timestamp, 0),
							'cat'     => getCategory($cat),
						);

						// Load row template
						$OUT .= loadTemplate('admin_list_links_row', true, $content);
					} else {
						// Load template for error
						$OUT .= loadTemplate('admin_list_links_problem',
						array(
								'sw'		=> $SW,
								'problem'	=> $PROBLEM,
								'data'		=> $DATA
						)
						);
					}
					$SW = 3 - $SW;
				}

				// Free memory
				SQL_FREERESULT($result);

				// Remember list in constant for the template
				$content['surname'] = $surname;
				$content['family']  = $family;
				$content['email']   = "<a href=\"" . generateEmailLink($email, 'user_data') . "\">".$email."</a>";
				$content['rows']    = $OUT;
				$content['nums']    = $nums;
				$content['userid']  = bigintval(getRequestElement('userid'));

				// Load final template
				loadTemplate('admin_list_links', false, $content);
			}
		} else {
			// No mails left to confirm
			loadTemplate('admin_settings_saved', false, sprintf(getMessage('ADMIN_MEMBER_LINKS'), getRequestElement('userid')));
		}
	} else {
		// User not found
		loadTemplate('admin_settings_saved', false, sprintf(getMessage('ADMIN_MEMBER_404'), getRequestElement('userid')));
	}
} else {
	// Output selection form with all confirmed user accounts listed
	addMemberSelectionBox();
}

// [EOF]
?>
